;Linex -- z80 ti86 asm
;first z80 assembly program
;Frank Yaul 7/4/04
#include "ti86asm.inc"
.org _asm_exec_ram
;***initialize
 di
 call _clrScrn
 ld hl,0
 ld (score),hl
 ld (tpos),hl ;overflow to cpos
 ld a,128
 ld (cpos),a
mloop:
;***update track
 ld a,($9000) ;useless mem
 ld b,a
 ld a,r
 add a,b
 ld ($9000),a ;randa
 cp 128
 jr c,tleft ;a<128
;tright:
 ld a,(tpos)
 add a,8
 jr cont1
tleft:
 ld a,(tpos)
 sub 8
 ;jr cont1
cont1:
 ld (tpos),a
 ld hl,$ffc0 ;row60
 call findpx
 ld (hl),%11000011 ;blockline sprite
;***get input
 ld a,%01111110 ;keyrow7
 out (1),a
 in a,(1)
 ld hl,cpos
;cleft:
 rra
 rra
 jr c,cright ;left wasnt pressed
 dec (hl)
 jr cont2
cright:
 rra
 jr c,cont2 ;right wasnt pressed
 inc (hl)
 ;jr cont2
cont2:
 ld a,(hl)
 ld hl,$fcf0 ;row16
 call findpx
 ld a,%01111110 ;car sprite
;***crash detect
 ld b,a
 and (hl)
 jr nz,end
  ld a,b
;***draw the car
 or (hl)
 ld (hl),a
;***scroll up 1px
 ld hl,$fc10
 ld de,$fc00
 ld bc,$3f0
 ldir
;***increase score
 ld hl,(score)
 inc hl
 ld (score),hl
 jr mloop
end:
;***endgame
 ld hl,(hscore)
 ld bc,(score)
 sbc hl,bc
 jr nc,cont3
;new highscore
 ld (hscore),bc
cont3:
;display scores
 ld hl,(score)
 xor a
 call _dispAHL
 call _newline
 ld hl,(hscore)
 xor a
 call _dispAHL
 call _newline
 ld hl,text
 call _puts
 ei
 ret
findpx:
;input 0-255 a, hl rowaddr
;output hl byteaddr
 and %11110000
 rlca
 rlca
 rlca
 rlca
 add a,l
 ld l,a ;a>>4+hl
 ret
;dynamic vars
tpos: .db 0
cpos: .db 0
score: .dw 0
;static vars
hscore: .dw 0
text: .db "LinexByFrank",0
 